/* http://stackoverflow.com/questions/198199/how-do-you-reverse-a-string-in-place-in-c-or-c */
#include "str.h"
#ifndef __MINGW32__
void strrev(char *p)
{
  char *q = p;
  while(q && *q) ++q; /* find eos */
  for(--q; p < q; ++p, --q) SWP(*p, *q);
}
#endif
/* reverse string in place */
void strrev_utf8(char *p)
{
  char *q = p;
  strrev(p); /* call base case */

  /* Ok, now fix bass-ackwards UTF chars. */
  while(q && *q) ++q; /* find eos */
  while(p < --q)
    switch( (*q & 0xF0) >> 4 ) {
    case 0xF: /* U+010000-U+10FFFF: four bytes. */
      SWP(*(q-0), *(q-3));
      SWP(*(q-1), *(q-2));
      q -= 3;
      break;
    case 0xE: /* U+000800-U+00FFFF: three bytes. */
      SWP(*(q-0), *(q-2));
      q -= 2;
      break;
    case 0xC: /* fall-through */
    case 0xD: /* U+000080-U+0007FF: two bytes. */
      SWP(*(q-0), *(q-1));
      q--;
      break;
    }
}

/* shift string left */
void _delete(char *ptr){
    for(;*ptr;ptr++)*ptr=*(ptr+1);
}

/* remove extra whitespace from string in place */
char *strip(char* url){
    char *save_ptr=url;
    /* remove tabs, linefeeds, and returns */
    while ((url = strpbrk(url,"\r\n\t"))) _delete(url);
    /* remove space at end */
    url=save_ptr;strrev_utf8(url);
    /* fprintf(stderr,">%s<\n",save_ptr); */
    for (;*url==' ';)_delete(url);
    url=save_ptr;strrev_utf8(url);
    /* remove extra spaces between words */
    while (( url = strchr(url,' '))) {
        while(url[0]==url[1]) _delete(url);
        url++;
    } /* remove space at start */
    url = save_ptr+strspn(save_ptr," ");
    /* fprintf(stderr,"[%s]\n",url); */
    return url;
}