/* http://www.geekhideout.com/urlcode.shtml
"CC0 To the extent possible under law,  Fred Bulback has waived all copyright and related or neighboring rights to URL Encoding/Decoding in C.
This work is published from:  United States."
*/
#include "url.h"

/* Converts a hex character to its integer value */
char from_hex(char ch) {
  return isdigit(ch) ? ch - '0' : tolower(ch) - 'a' + 10;
}

/* Converts an integer value to its hex character*/
char to_hex(char code) {
  static char hex[] = "0123456789abcdef";
  return hex[code & 15];
}

/* Returns a url-encoded version of str */
/* IMPORTANT: be sure to free() the returned string after use */
char *url_encode(const char *in_p) {
  const char *sp = in_p;
  char *buffer = malloc(strlen(in_p) * 3 + 1), *pbuffer = buffer;
  if(!buffer){fprintf(stderr,"Out of memory error.");exit(1);}
  while (*sp) {
    if (isalnum(*sp) || *sp == '-' || *sp == '_' || *sp == '.' || *sp == '~') 
      *pbuffer++ = *sp;
/*     else if (*sp == ' ') 
      *pbuffer++ = '+'; */
    else 
      *pbuffer++ = '%', *pbuffer++ = to_hex(*sp >> 4), *pbuffer++ = to_hex(*sp & 15);
    sp++;
  }
  *pbuffer = '\0';
  return buffer;
}

/* Returns a url-decoded version of str */
/* IMPORTANT: be sure to free() the returned string after use */
char *url_decode(const char *str) {
  const char *pstr = str;
  char *buffer = malloc(strlen(str) + 1), *pbuffer = buffer;
  if(!buffer){fprintf(stderr,"Out of memory error.");exit(1);}
  while (*pstr) {
    if (*pstr == '%') {
      if (pstr[1] && pstr[2]) {
        *pbuffer++ = from_hex(pstr[1]) << 4 | from_hex(pstr[2]);
        pstr += 2;
      }
    } else if (*pstr == '+') { 
      *pbuffer++ = ' ';
    } else {
      *pbuffer++ = *pstr;
    }
    pstr++;
  }
  *pbuffer = '\0';
  return buffer;
}
